function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RouterCache {
  constructor() {
    _defineProperty(this, "cached", void 0);

    _defineProperty(this, "seed", void 0);

    this.cached = {};
    this.seed = 0;
  }

  create(data, id = 0) {
    const key = `[route_cache_id:${id ? `[${id}]` : ''}${++this.seed}]`;
    this.cached[key] = data;
    return key;
  }

  flush(seed) {
    if (!seed) return;
    let ret = this.cached[seed];
    delete this.cached[seed];
    return ret;
  }

}

const routeCache = new RouterCache();
export default routeCache;