function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { REACT_LAZY_TYPE } from './route-guard';
export class RouteLazy {
  constructor(ctor, options = {}) {
    _defineProperty(this, "_ctor", void 0);

    _defineProperty(this, "_result", void 0);

    _defineProperty(this, "resolved", void 0);

    _defineProperty(this, "$$typeof", REACT_LAZY_TYPE);

    _defineProperty(this, "options", void 0);

    _defineProperty(this, "updaters", []);

    this._ctor = ctor;
    this._result = null;
    this.options = options;
    this.render = this.render.bind(this);
    this.resolved = false;
    this.updaters = [];
  }

  toResolve(...args) {
    return new Promise(async (resolve, reject) => {
      if (this.resolved) return resolve(this._result);

      let _resolve = v => {
        v = v && v.__esModule ? v.default : v;
        this.updaters.forEach(updater => v = updater(v) || v);
        this._result = v;
        this.resolved = true;
        resolve(v);
      };

      let component = this._ctor.prototype instanceof React.Component ? this._ctor : this._ctor instanceof Promise ? await this._ctor : this._ctor(...args);
      if (!component) throw new Error('component should not null!');

      if (component instanceof Promise) {
        component.then(_resolve).catch(function () {
          return reject(...arguments);
        });
      } else _resolve(component);
    });
  }

  render(props, ref) {
    if (!this.resolved || !this._result) return null;
    return React.createElement(this._result, _objectSpread({}, props, {
      ref
    }));
  }

}
export function hasRouteLazy(route) {
  const config = route.config || route;
  if (config.components instanceof RouteLazy) return true;

  if (config.components) {
    for (let key of Object.keys(config.components)) {
      if (config.components[key] instanceof RouteLazy) return true;
    }
  }

  return false;
}
export function hasMatchedRouteLazy(matched) {
  return matched && matched.some(r => hasRouteLazy(r));
}
export function lazyImport(importMethod, options = {}) {
  return new RouteLazy(importMethod, options || {});
}